import { ref as h, provide as L, onMounted as O, openBlock as _, createElementBlock as b, createElementVNode as R, renderSlot as S, inject as y, onUnmounted as f } from "vue";
const P = "https://api.longdo.com/map/", v = {
  apiKey: null,
  src: null,
  debug: !1,
  loaded: null,
  scriptReady: null,
  prepare: function({ apiKey: t = null, src: a = null, debug: e = !1, loaded: o = null }) {
    if (!(typeof window > "u")) {
      if (window.longdo) {
        console.warn("Longdo Map Vue: Longdo Map API is already loaded");
        return;
      }
      this.apiKey = t, this.src = a || P, this.debug = e, this.loaded = o;
    }
  },
  loadScript: function() {
    if (this.scriptReady !== null)
      return;
    let t = this.src, a = {};
    this.apiKey && (a.key = this.apiKey), this.debug && (a.debug = !0);
    const e = new URLSearchParams(a);
    e && (t += `?${e}`), this.scriptReady = new Promise((o, r) => {
      let d = document.createElement("script");
      d.onload = () => {
        this.loaded && typeof this.loaded == "function" && this.loaded(window.longdo), o();
      }, d.onerror = () => {
        r();
      }, d.async = !0, d.src = t, document.body.appendChild(d);
    });
  }
}, j = {
  __name: "Map",
  props: {
    projection: {
      type: String,
      default: null
    },
    layer: {
      type: Array,
      default: null
    },
    zoom: {
      type: Number,
      default: null
    },
    zoomRange: {
      type: Object,
      default: null
    },
    location: {
      type: Object,
      default: null
    },
    ui: {
      type: String,
      default: null
    },
    input: {
      type: Boolean,
      default: null
    },
    autoResize: {
      type: Boolean,
      default: null
    },
    lastView: {
      type: Boolean,
      default: null
    },
    smoothZoom: {
      type: Boolean,
      default: null
    },
    language: {
      type: String,
      default: null
    }
  },
  emits: ["load"],
  setup(t, { emit: a }) {
    v.loadScript();
    const e = t;
    let o = null, r = !1;
    const d = h(null), n = new Promise((u, s) => {
      (function w(M = 0) {
        if (r) {
          u(o);
          return;
        } else if (M === 3e4) {
          s("Longdo Map Vue: Cannot create Longdo Map instance");
          return;
        }
        setTimeout(() => {
          w(M);
        }, 10), M += 10;
      })();
    }), c = a;
    L("mapReady", n);
    function l() {
      if (typeof window.longdo != "object") {
        console.error("Longdo Map Vue: Longdo Map API is not found");
        return;
      }
      let u = i();
      u.placeholder = d.value, o = new window.longdo.Map(u), u.zoomRange && o.zoomRange(u.zoomRange), o.Event.bind("ready", () => {
        r = !0, c("load", o);
      });
    }
    function i() {
      const u = {};
      for (const s in e)
        e[s] !== null && (s === "projection" ? u.projection = window.longdo.Projections[e.projection] : s === "layer" ? u.layer = p(e.layer) : s === "ui" ? u.ui = window.longdo.UiComponent[e.ui] : u[s] = e[s]);
      return u;
    }
    function p(u) {
      let s = [];
      for (let w of u)
        s.push(window.longdo.Layers[w]);
      return s;
    }
    return O(() => {
      v.scriptReady.then(() => {
        l();
      });
    }), (u, s) => (_(), b("div", null, [
      R("div", {
        style: { width: "100%", height: "100%" },
        ref_key: "placeholder",
        ref: d
      }, null, 512),
      S(u.$slots, "default")
    ]));
  }
}, k = {
  __name: "Marker",
  props: {
    location: {
      type: Object,
      default: null
    },
    title: {
      type: String,
      default: null
    },
    icon: {
      type: Object,
      default: null
    },
    detail: {
      type: String,
      default: null
    },
    popup: {
      type: Object,
      default: null
    },
    visibleRange: {
      type: Object,
      default: null
    },
    clickable: {
      type: Boolean,
      default: null
    },
    draggable: {
      type: Boolean,
      default: null
    },
    weight: {
      type: String,
      default: null
    },
    rotate: {
      type: Number,
      default: null
    },
    iconStyle: {
      type: String,
      default: null
    }
  },
  emits: ["add"],
  setup(t, { emit: a }) {
    let e = null, o = null;
    const r = y("mapReady", null), d = a, n = t;
    function c() {
      const i = {};
      for (const p in n)
        if (n[p] !== null)
          if (p === "weight") {
            let u = window.longdo.OverlayWeight[n.weight];
            u && (i.weight = u);
          } else p === "iconStyle" ? i.style = n.iconStyle : i[p] = n[p];
      return i;
    }
    function l(i, p) {
      o = new window.longdo.Marker(i, p), e == null || e.Overlays.add(o), d("add", o);
    }
    return (() => {
      if (r === null) {
        console.error("Longdo Map Vue: Longdo Map component is not ready");
        return;
      }
      r.then((i) => {
        if (e = i, !n.location || isNaN(n.location.lat) || isNaN(n.location.lon)) {
          console.error("Longdo Map Vue: Invalid marker location");
          return;
        }
        l(n.location, c());
      }).catch((i) => {
        console.error(i);
      });
    })(), f(() => {
      e == null || e.Overlays.remove(o);
    }), () => {
    };
  }
};
function g() {
  return {
    location: {
      type: [Object, Array],
      default: null
    },
    radius: {
      type: Number,
      default: null
    },
    size: {
      type: [Number, Object],
      default: null
    },
    title: {
      type: String,
      default: null
    },
    detail: {
      type: String,
      default: null
    },
    label: {
      type: [String, Boolean],
      default: null
    },
    labelOptions: {
      type: Object,
      default: null
    },
    popup: {
      type: Object,
      default: null
    },
    visibleRange: {
      type: Object,
      default: null
    },
    lineWidth: {
      type: Number,
      default: null
    },
    lineColor: {
      type: String,
      default: null
    },
    fillColor: {
      type: String,
      default: null
    },
    lineStyle: {
      type: String,
      default: null
    },
    pivot: {
      type: Object,
      default: null
    },
    clickable: {
      type: Boolean,
      default: null
    },
    editable: {
      type: Boolean,
      default: null
    },
    pointer: {
      type: Boolean,
      default: null
    },
    draggable: {
      type: Boolean,
      default: null
    },
    rotatable: {
      type: Boolean,
      default: null
    },
    weight: {
      type: String,
      default: null
    },
    texture: {
      type: String,
      default: null
    },
    textureAlpha: {
      type: Number,
      default: null
    },
    linePattern: {
      type: String,
      default: null
    }
  };
}
function m(t) {
  const a = {};
  for (let e in t)
    if (t[e] !== null)
      if (e === "weight") {
        let o = window.longdo.OverlayWeight[t.weight];
        o && (a.weight = o);
      } else e === "lineStyle" ? a.lineStyle = window.longdo.LineStyle[t.lineStyle] : a[e] = t[e];
  return a;
}
const V = {
  __name: "Polyline",
  props: g(),
  emits: ["add"],
  setup(t, { emit: a }) {
    let e = null, o = null;
    const r = y("mapReady", null), d = a, n = t;
    function c(l, i) {
      o = new window.longdo.Polyline(l, i), e == null || e.Overlays.add(o), d("add", o);
    }
    return (() => {
      if (r === null) {
        console.error("Longdo Map Vue: Longdo Map component is not ready");
        return;
      }
      r.then((l) => {
        if (e = l, !n.location) {
          console.error("Longdo Map Vue: Invalid polyline location");
          return;
        }
        c(n.location, m(n));
      }).catch((l) => {
        console.error(l);
      });
    })(), f(() => {
      e == null || e.Overlays.remove(o);
    }), () => {
    };
  }
}, B = {
  __name: "Polygon",
  props: g(),
  emits: ["add"],
  setup(t, { emit: a }) {
    let e = null, o = null;
    const r = y("mapReady", null), d = a, n = t;
    function c(l, i) {
      o = new window.longdo.Polygon(l, i), e == null || e.Overlays.add(o), d("add", o);
    }
    return (() => {
      if (r === null) {
        console.error("Longdo Map Vue: Longdo Map component is not ready");
        return;
      }
      r.then((l) => {
        if (e = l, !n.location) {
          console.error("Longdo Map Vue: Invalid polygon location");
          return;
        }
        c(n.location, m(n));
      }).catch((l) => {
        console.error(l);
      });
    })(), f(() => {
      e == null || e.Overlays.remove(o);
    }), () => {
    };
  }
}, N = {
  __name: "Circle",
  props: g(),
  emits: ["add"],
  setup(t, { emit: a }) {
    let e = null, o = null;
    const r = y("mapReady", null), d = a, n = t;
    function c(l, i, p) {
      o = new window.longdo.Circle(l, i, p), e == null || e.Overlays.add(o), d("add", o);
    }
    return (() => {
      if (r === null) {
        console.error("Longdo Map Vue: Longdo Map component is not ready");
        return;
      }
      r.then((l) => {
        if (e = l, !n.location) {
          console.error("Longdo Map Vue: Invalid circle location");
          return;
        }
        if (!n.radius || isNaN(n.radius)) {
          console.error("Longdo Map Vue: Invalid circle radius");
          return;
        }
        c(n.location, n.radius, m(n));
      }).catch((l) => {
        console.error(l);
      });
    })(), f(() => {
      e.Overlays.remove(o);
    }), () => {
    };
  }
}, I = {
  __name: "Polycurve",
  props: g(),
  emits: ["add"],
  setup(t, { emit: a }) {
    let e = null, o = null;
    const r = y("mapReady", null), d = a, n = t;
    function c(l, i) {
      if (o = new window.longdo.Polycurve(l, i), o.location === void 0) {
        console.warn("Longdo Map Vue: Polycurve is not supported");
        return;
      }
      e == null || e.Overlays.add(o), d("add", o);
    }
    return (() => {
      if (r === null) {
        console.error("Longdo Map Vue: Longdo Map component is not ready");
        return;
      }
      r.then((l) => {
        if (e = l, !n.location) {
          console.error("Longdo Map Vue: Invalid polycurve location");
          return;
        }
        c(n.location, m(n));
      }).catch((l) => {
        console.error(l);
      });
    })(), f(() => {
      e == null || e.Overlays.remove(o);
    }), () => {
    };
  }
}, z = {
  __name: "Dot",
  props: g(),
  emits: ["add"],
  setup(t, { emit: a }) {
    let e = null, o = null;
    const r = y("mapReady", null), d = a, n = t;
    function c(l, i) {
      o = new window.longdo.Dot(l, i), e == null || e.Overlays.add(o), d("add", o);
    }
    return (() => {
      if (r === null) {
        console.error("Longdo Map Vue: Longdo Map component is not ready");
        return;
      }
      r.then((l) => {
        if (e = l, !n.location) {
          console.error("Longdo Map Vue: Invalid dot location");
          return;
        }
        c(n.location, m(n));
      }).catch((l) => {
        console.error(l);
      });
    })(), f(() => {
      e == null || e.Overlays.remove(o);
    }), () => {
    };
  }
}, C = {
  __name: "Rectangle",
  props: g(),
  emits: ["add"],
  setup(t, { emit: a }) {
    let e = null, o = null;
    const r = y("mapReady", null), d = a, n = t;
    function c(l, i) {
      o = new window.longdo.Rectangle(l, i), e == null || e.Overlays.add(o), d("add", o);
    }
    return (() => {
      if (r === null) {
        console.error("Longdo Map Vue: Longdo Map component is not ready");
        return;
      }
      r.then((l) => {
        if (e = l, !n.location) {
          console.error("Longdo Map Vue: Invalid rectangle location");
          return;
        }
        if (!n.size) {
          console.error("Longdo Map Vue: Invalid rectangle size");
          return;
        }
        c(n.location, n.size, m(n));
      }).catch((l) => {
        console.error(l);
      });
    })(), f(() => {
      e.Overlays.remove(o);
    }), () => {
    };
  }
}, $ = function(t) {
  v.prepare(t);
}, D = {
  install(t, a) {
    a.load && $(a.load), t.component("LongdoMap", j), t.component("LongdoMapMarker", k), t.component("LongdoMapPolyline", V), t.component("LongdoMapPolygon", B), t.component("LongdoMapCircle", N), t.component("LongdoMapPolycurve", I), t.component("LongdoMapDot", z), t.component("LongdoMapRectangle", C);
  }
};
export {
  j as LongdoMap,
  N as LongdoMapCircle,
  z as LongdoMapDot,
  $ as LongdoMapLoad,
  k as LongdoMapMarker,
  I as LongdoMapPolycurve,
  B as LongdoMapPolygon,
  V as LongdoMapPolyline,
  C as LongdoMapRectangle,
  D as default
};
